abuild.in 44.5 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
55 56 57 58 59
fi	
	

# functions
msg() {
60
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
61 62 63
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
64 65 66 67 68 69 70
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
71 72 73 74 75 76
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
77 78 79 80 81 82
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
83 84 85 86 87 88
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
89 90 91 92 93 94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
95
}
Natanael Copa's avatar
Natanael Copa committed
96

Linux User's avatar
Linux User committed
97
set_xterm_title() {
98
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
99
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
100 101 102 103 104
	fi
} 

cleanup() {
	set_xterm_title ""
105
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
106
		msg "Uninstalling dependencies..."
107
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
108
	fi
109 110 111
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
112 113
}

Natanael Copa's avatar
Natanael Copa committed
114
die() {
Linux User's avatar
Linux User committed
115
	error "$@"
Linux User's avatar
Linux User committed
116
	cleanup
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	exit 1
}

120
# check if apkbuild is basicly sane
121
default_sanitycheck() {
122
	local i= j= suggestion=
123
	msg "Checking sanity of $APKBUILD..."
124 125 126
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
127
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
128
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
129 130
			die "$pkgver is not a valid version"
	fi
131
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
132 133 134 135
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
136 137
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
138 139
		die "replaces_priority must be a number"
	fi
140 141 142 143 144 145 146
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

147 148 149 150 151 152 153 154 155 156
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
157
	for i in $install; do
158
		local n=${i%.*}
159
		local suff=${i##*.}
160 161 162 163 164
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
165
			die "$i: install script does not match pkgname or any subpackage"
166
		fi
167
		[ -e "$startdir/$i" ] || die "install script $i is missing"
168 169 170 171 172 173
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
174 175
	done
	
176 177 178 179 180 181 182 183
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
184

185 186
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
187 188
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
189 190 191 192
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
193 194
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
Natanael Copa's avatar
Natanael Copa committed
195
			case "$i" in
196
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
197
			esac
198 199
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
200

201 202 203 204 205 206 207 208
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
209
		done
210
	done
211

212 213 214
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
215 216

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
217 218

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
219 220 221
	return 0
}

222 223 224 225
sanitycheck() {
	default_sanitycheck
}

226 227
sumcheck() {
	local algo="$1" sums="$2"
228
	local dummy f endreturnval originalparams origin file
229 230 231 232 233 234 235 236

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
237
	fi
238
	fetch || return 1
239
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
240
	cd "$srcdir" || return 1
241 242
	IFS=$'\n'
	endreturnval=0
243
	for src in $sums; do
244
		origin=$1; shift
245
		echo "$src" | ${algo}sum -c
246
		if [ $? -ne 0 ]; then
247
			endreturnval=1
248
			is_remote $origin || continue
249
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
250 251 252 253 254 255 256 257
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
258 259
}

260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
284 285
# verify upstream sources
sourcecheck() {
286 287 288 289 290 291 292 293 294 295
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
296
	done
297
	return 0
Natanael Copa's avatar
Natanael Copa committed
298
}
299

300 301 302
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
303
	while getopts "C:Lko:s" opt; do
304
		case $opt in
305
		'L') ;; # --location. wget does this by default
306
		'f') ;; # --fail. wget does this by default
307 308 309 310 311 312 313 314 315 316
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
317 318
uri_fetch() {
	local uri="$1"
319
	local d="${uri##*/}"	# $(basename $uri)
320
	local opts
321
	[ -n "$quiet" ] && opts="-s"
322 323

	local lockfile="$SRCDEST/$d".lock
324

325 326 327 328 329
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
330
	esac
331 332

	case "$uri" in
333
		https://*) opts="-k";;
334
	esac
335

Natanael Copa's avatar
Natanael Copa committed
336
	mkdir -p "$SRCDEST"
337 338 339

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
340 341
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
342 343 344

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

345 346
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
347
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
348
	fi
Linux User's avatar
Linux User committed
349
	msg "Fetching $uri"
350 351

	# fallback to wget if curl is missing. useful for bootstrapping
352
	local fetcher=
353 354
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
355 356
	else
		fetcher=curl
357
		opts="$opts -L -f -k"
358 359 360
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
361
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
362

363
	) 9>$lockfile
364 365 366 367

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
368 369
}

370 371
is_remote() {
	case "$1" in
372
		http://*|ftp://*|https://*|saveas-*://*)
373 374 375 376 377
			return 0;;
	esac
	return 1
}

378 379 380 381 382
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
383 384 385 386 387
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
388 389 390 391
	fi
	uri_fetch "$uri"
}

392
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
393 394
	local s
	mkdir -p "$srcdir"
395 396
	for s in $source; do
		if is_remote "$s"; then
397
			uri_fetch_mirror "$s" || return 1
398 399 400 401
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
402 403 404
	done
}

405 406 407 408
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
409 410 411 412 413 414 415 416 417 418 419 420 421 422 423
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
424
# unpack the sources
425
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
426
	local u
427 428
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
429
		initdcheck || return 1
430
	fi
Natanael Copa's avatar
Natanael Copa committed
431 432 433 434
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
435 436 437
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
438
			*.tar.gz|*.tgz)
439
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
440 441
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
442
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
443
				tar -C "$srcdir" -jxf "$s" || return 1;;
444 445 446 447
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
448 449 450
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
451 452 453
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
454 455 456 457
		esac
	done
}

458 459 460 461
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
462 463
# cleanup source and package dir
clean() {
464
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
465
	rm -rf "$srcdir"
466
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
467 468 469 470 471 472
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
473 474 475 476
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
477 478 479
	done
}

480 481 482 483 484 485 486 487 488 489
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
490 491
cleanpkg() {
	local i
492
	getpkgver || return 1
493
	msg "Cleaning built packages..."
494
	for i in $(listpkgnames); do
495 496
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
497
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
498
	done
499
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
500 501
}

502 503 504
# clean all packages except current
cleanoldpkg() {
	local i j
505
	getpkgver || return 1
506
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
507
	for i in $(listpkgnames); do
508 509 510 511 512
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
513 514 515 516
		done
	done
	return 0
}
517 518 519

mkusers() {
	local i
520 521 522 523 524 525
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
526 527
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
528
			local gopt=
529
			msg "Creating user $i"
530 531 532
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
533
			$ADDUSER -S -D -H $gopt $i || return 1
534 535 536 537 538
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
539 540
runpart() {
	local part=$1
541
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
542 543 544 545
	$part || die "$part failed"
}

# override those in your build script
546 547 548 549 550 551 552 553
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
554 555 556 557
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
558
build() {
559
	:
Natanael Copa's avatar
Natanael Copa committed
560 561
}

562 563 564
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
565
	mkdir -p "$PKGDEST"
566 567 568
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
569 570 571 572 573 574 575 576 577
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

578 579 580
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
581
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
582 583 584 585 586 587 588 589
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
590 591 592 593 594 595 596 597 598 599 600 601 602
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
603 604 605 606 607 608 609 610 611
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
612 613 614 615 616 617 618 619 620
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
621 622 623
	return 0
}

624
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
625 626
	local i
	cd "$startdir"
627
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
628 629
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
630
		msg "Running split function $func..."
631 632
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
633
			$0 $func prepare_package || return 1
634
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
635
	done
636
	postcheck "$pkgdir" "$pkgname" || return 1
637 638
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
639
		warning "Found /usr/share/locale"
640
		warning2 "Maybe add \$pkgname-lang to subpackages?"
641
	fi
Natanael Copa's avatar
Natanael Copa committed
642 643
}

644
default_lang() {
645
	pkgdesc="Languages for package $pkgname"
646 647 648 649 650 651 652 653 654 655 656 657 658
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

659
default_lang_subpkg() {
660 661 662 663
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
664
	pkgdesc="$pkgname language pack for $lang"
665 666
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
667 668 669 670 671
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
672
		|| return 1
673 674 675 676 677
	done
}

lang_subpkg() {
	default_lang_subpkg
678 679 680 681 682 683 684 685 686 687 688
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

689 690 691 692 693 694 695 696 697 698 699 700
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

701 702 703 704 705 706
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

707
prepare_metafiles() {
708
	getpkgver || return 1
709 710
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
711
	local dir=${subpkgdir:-$pkgdir}
712
	local pkg="$name-$pkgver-r$pkgrel.apk"
713
	local pkginfo="$controldir"/.PKGINFO
714
	local sub
Natanael Copa's avatar
Natanael Copa committed
715 716 717
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
718
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
719 720
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
721
	local parch="$CARCH"
722 723 724 725 726

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
727

728
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
729
	if [ -n "$FAKEROOTKEY" ]; then
730
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
731
	fi
732 733
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
734
pkgname = $name
735
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
736 737 738 739 740
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
741
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
742
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
743
EOF
744 745
	local i deps
	deps="$depends"
746
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
747 748
		for i in $install $triggers; do
			local s=${i%=*}
749
			[ "$name" != "${s%.*}" ] && continue
750
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
751 752 753 754 755
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
756 757
	fi
	
758 759 760 761 762 763 764 765 766 767
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

768
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
769
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
770 771
	fi

Natanael Copa's avatar
Natanael Copa committed
772
	for i in $license; do
773
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
774 775
	done
	for i in $replaces; do
776
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
777
	done
778
	for i in $deps; do
779
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
780 781
	done
	for i in $conflicts; do
782
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
783 784
	done
	for i in $provides; do
785
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
786
	done
787 788 789 790 791 792
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
793 794 795
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
796 797

	local metafiles=".PKGINFO"
798 799 800
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
801
		if [ "$n" != "$name" ]; then
802 803
			continue
		fi
804
		script=${f#$name}
805
		msg "Adding $script"
806
		cp "$startdir/$f" "$controldir/$script" || return 1
807
		chmod +x "$controldir/$script"
808 809
		metafiles="$metafiles $script"
	done
810
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
811
}
812

813 814
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
815
	local etype= soname= file= sover=
816
	[ "$arch" = "noarch" ] && return 0
817
	options_has "!tracedeps" && return 0
818
	# lets tell all the places we should look for .so files - all rpaths
819 820
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
821
		>"$controldir"/.rpaths
822 823 824 825 826 827 828
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
829 830
}

831 832 833 834 835 836 837 838 839 840 841 842
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

843 844 845 846 847
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

848 849 850 851 852 853 854
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
855 856 857
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
858 859 860 861
	fi
	return 0
}

862
prepare_package() {
863
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
864
	stripbin
865 866
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
867 868 869 870 871 872 873 874
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

898 899 900 901
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

902 903 904
trace_apk_deps() {
	local name="$1"
	local dir="$2"
905
	local i= found= autodeps= deppkgs= missing=
906
	msg "Tracing dependencies..."
907 908 909
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
910
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
911 912 913 914
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
915
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
916 917
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
918
		msg "  added libgcc (due to libpthread)"
919
	fi
920
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
921 922 923 924 925
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

		if subpkg_provides "$i" || $APK info -q -e "so:$i"; then
			autodeps="$autodeps so:$i"
926
		else
927
			missing="$missing $i"
928
		fi
929 930 931
	done

	# find all packages that holds the so files
932
	if [ -f "$dir"/.rpaths ]; then
933 934
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
935 936 937
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

938
	for found in $deppkgs; do
939
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
940 941 942
			warning "You can remove '$found' from depends"
			continue
		fi
943
		autodeps="$autodeps $found"
944
	done
945

946
	echo "# automatically detected:" >> "$dir"/.PKGINFO
947
	if [ -f "$dir"/.provides-so ]; then
948
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
949
			>> "$dir"/.PKGINFO
950 951
	fi
	[ -z "$autodeps" ] && return 0
952
	for i in $autodeps; do
953 954
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
955 956
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
957 958
}

959
find_scanelf_paths() {
960
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
961
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
962
	if [ -n "$ldpath" ]; then
963
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
964 965
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
966 967
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
968
		while read i; do
969 970 971 972
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
973
			fi
974
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
975
		done < "$rpaths"
976 977 978 979 980 981
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
982
	local opt=
983 984 985

	# allow spaces in paths
	IFS=:
986
	set -- $(find_scanelf_paths "$datadir")
987 988
	unset IFS

989 990 991
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
992 993
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
994
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
995 996
		# if soname field is missing, soname will be the filepath
		sover=0
997 998
		if [ -z "$file" ]; then
			file="$soname"
999
			soname=${soname##*/}
1000 1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013
		fi

		# we only want shared libs
		case $soname in
		*.so|*.so.[0-9]*);;
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1014 1015 1016 1017
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1018 1019 1020
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1021
		list_has "$soname" $somask && continue
1022
		echo "$soname $sover"
1023 1024 1025 1026 1027 1028 1029 1030 1031 1032
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1033 1034 1035 1036 1037

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1038
	| while read soname; do
1039
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1040 1041 1042
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1043 1044 1045
	done > "$controldir"/.needs-so
}

1046 1047 1048 1049 1050 1051 1052 1053
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1054
create_apks() {
1055
	local file= dir= name= ver= apk= datadir= size=
1056
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1057
	mkdir -p "$PKGDEST"
1058 1059 1060 1061 1062 1063 1064 1065 1066
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1067
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1068 1069 1070
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1071
		size=$(pkginfo_val size $file | human_size)
1072 1073 1074
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1075 1076

		trace_apk_deps "$name" "$dir" || return 1
1077
		msg "Package size: ${size}"
1078
		msg "Compressing data..."
1079
		(
1080 1081
		cd "$datadir"
		# data.tar.gz
1082 1083 1084 1085 1086 1087
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1088

1089
		msg "Create checksum..."
1090 1091 1092 1093 1094
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1095
		cd "$dir"
1096 1097
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1098
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1099

1100
		msg "Create $apk"
1101 1102
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1103
		)
1104
	done
1105
	subpkgname=
1106 1107
}

1108
clean_abuildrepo() {
1109
	local apk
1110 1111 1112
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
1113
	for d in "$abuildrepo/$CARCH"; do
1114 1115
		[ -L "$d" ] && rm "$d"
	done
1116

1117 1118
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
1119 1120 1121 1122
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
1123
}
1124

1125
mklinks_abuildrepo() {
1126 1127
	local apk
	mkdir -p "$abuildrepo"/$CARCH
1128
	cd "$abuildrepo" || return 1
1129
	# create links for this package
1130
	for apk in $(listpkg); do
1131
		[ -f "$PKGDEST"/$apk ] || continue
1132
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
1133
	done
1134 1135 1136 1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
1148

1149
	msg "Updating the cached abuild repository index..."
1150 1151
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
1152 1153
	if [ -f "$index" ]; then
		oldindex="--index $index"
1154
	fi
1155
	$APK index --quiet $oldindex --output "$index".unsigned \
Natanael Copa's avatar